var kSystemOutputSourceType = "system output";
var kSystemEffectsSourceType = "effects output";
var kSystemInputSourceType = "system input";
var kApplicationSourceType = "application";

markup.push({
	OutputListItem: sourceListItemView(1.0, null, true, true, kSystemOutputSourceType, true),
	EffectsListItem: sourceListItemView(1.0, null, true, false, kSystemEffectsSourceType, true), // not selectable
	InputListItem: sourceListItemView(1.0, null, true, false, kSystemInputSourceType, false),
	AppSourceListItem: sourceListItemView(1.0, null, false, true, kApplicationSourceType, true),
	"AlertButton" : {
		"+" : "ButtonView",
		gxIntrinsicHeight: 30,
		gxIntrinsicWidth: 30,
		gxBaselineOffset: 11,
		gxLayerZPosition: kSourceListCollapsedElementLevel + 1,
		gxBackPainter: null,
		gxForePainter: {
			"+": "ControlFore.black",
		},
		gxTitle: "\u{26A0}\u{FE0F}",
	}
});

function sourceListItemView(volumeSliderMax, detents, outputItem, showEQ, sourceType, isOutputType) {
	var normalHeight = 36;
	var volumeSliderMax = volumeSliderMax || 1.5;
	var volumeSliderDetents = "0,1";
	var isSelectable = selectable || true;
	var topPadding = 7;
	var leftPadding = 10;
	var rightPadding = 10.5;
	if (volumeSliderMax > 1) {
		volumeSliderDetents = "0,1," + volumeSliderMax
	}
	return {
		nsClass: "SoundSource.TCSourceView",  
		axIsIgnored: false,
		axTitleKeyPath: "axTitle",
		axHelpKeyPath: "axHelp",
		axRoleDescription: "Source List Item",
		axDescriptionKeyPath: "axDescription",
		multipleSelection: false,
		gxExpandOnMouseClick: false,
		selectable: true,
		gxDrawsSelected: true,
		gxDrawsFocused: false,
		gxLayoutSubviews: true,
		gxIntrinsicHeight: normalHeight,
		gxValueKeyPath: "",
		gxStylesKeyPath: "advancedSectionStyle",
		gxForePainter: {
			nsClass: "SoundSource.TCAdvancedViewBackgroundPainter",
			gxEdgeInsets: "12.5,45.5,12.5,12.5",
			"pointWidth": 19,
			"pointHeight": 9, // Just high enough to not be visible when advanced section is hidden
			gxFrameColor: "name:controlFrame",
			gxFillColor: "name:lightMinty",
		}, 
		gxBackPainter: {
			nsClass: "GXRoundRectPainter",
			gxEdgeInsets: "0,0,0,0",
			gxCornerRadius: 0, // No corners so other views can't appear from below
			gxStrokeWidth: 2,
			gxFillColor: "name:background",
			"open" : { 
				gxCornerRadius: 10,
			},
			"selected" : {
				gxCornerRadius: 10,
				gxFillColor: "name:superLightMinty",
				gxFrameColor: "name:darkMinty",
			}, 
			"dragging" : {
				gxCornerRadius: 10,
			},
		}, 
		gxLayout: [
			"H:|-0-[self]-0-|",
			"V:|-" + (topPadding + 0.5) + "-[sourceIcon(20)]",
			"V:|-" + (topPadding + 3) + "-[sourceName]",
			"H:[sourceName(>=90)]-(>=0)-[volumeIndicator]-(>=0)-[volumeSlider][spacer(==volumeSliderReadout)]-6-[magicBoostButton(26)]-(>=0)-[showEffectsButton]&alignBaseline",
			"H:[showEffectsButton]-(-10)-[fxBadge]",
			"V:[showEffectsButton]-(-26)-[fxBadge]",
			"V:|-" + topPadding + "-[deviceSelectPopup(20)]",
			"H:|-"+ leftPadding +"-[sourceIcon(20.5)]-5-[sourceName]-(5)-[volumeIndicator]-0-[volumeSlider(145)]-(0)-[volumeSliderReadout(35)]",
			"H:[volumeSlider]-(0)-[volumeSliderReadout]",
			"H:[sourceName]-(>=0)-[volumeSliderReadout]&alignBaseline",
			"H:[sourceDelete(==sourceIcon)]-(<=0)-[sourceIcon]&alignCenterY",
			"V:[sourceDelete(==sourceIcon)]-(<=0)-[sourceIcon]&alignCenterX",
			"H:[sourceDeleteForAX]-(<=0)-[sourceIcon]&alignCenterY",
			"V:[sourceDeleteForAX]-(<=0)-[sourceIcon]&alignCenterX",
			"H:[magicBoostButton]-8-[levelMetersEnabled]-12-[deviceSelectPopup(150)]",
			"H:[deviceSelectPopup]-11.5-[showEffectsButton]-"+rightPadding+"-|",
			"H:[deviceSelectPopup]-(<=-32)-[spinnerHolder(15)]",
			"V:|-10.5-[spinnerHolder(15)]",
			"H:[magicBoostButton]-10-[muteAlert]&alignBaseline",
			"H:[magicBoostButton]-10-[deviceAlert]&alignBaseline",
			"V:[levelMetersDisabled]-(<=0)-[levelMetersEnabled]&alignCenterX"
		], 
		"expansionView": {
			nsClass: GXDrawView,
			gxLayout: [
				"H:|-0-[self]-0-|",
				"V:|-" + (normalHeight) + "-[self]",
			],
			gxCanDrawSubviewsIntoLayer: true,
			gxWantsLayer: true, 
			gxChildViews: {
				effectsList: {
					nsClass: "GXListView",
					multipleSelection: false, 
					axIsIgnored: true,
					gxLayout: [
						"H:|-0-[self]-5-|",
						"V:|-0-[self]-0-|",
					],
					gxChildViews: {
						headerView: effectPanelView(outputItem, showEQ),
						footerView: {
							nsClass: GXDrawView,
							gxLayerZPosition: 5,
							gxLayout: [
								"H:|-0-[self]-20-|"
							],
							gxIgnoreMouseClick: true,
							gxIntrinsicHeight: 51,
							gxChildViews: {
								"addEffect": {
									"+": "FlatButtonPopup.size12.green.down",
									gxLayout: [
										"H:|-23-[self(100)]&alignCenterY",
										"V:[self(24)]-23-|"
									],
									gxForePainter: {
										"+": "FlatButtonFore",
										gxEdgeInsets: "-10,-1,10,0"
									},
									gxValueKeyPath: "customEffects.addEffect",
									gxShowOnKey: "hasEffectsSection",
									gxMenuItemsKeyPath: "customEffects.effectsMenuItems", 
									axTitle: "Add Effect",
									gxPullsDown: true,
									gxToolTipKeyPath: "addEffectHelp",
								},
								"latencyWarning": {
									"+" : "LabelView.size12.right.fontColor",
									gxValueKeyPath: "",
									gxShowOnKey: "customEffects.showLatencyWarning",
									gxLayout: [
										   "H:[self(450)]-0-|",
										   "V:[self(24)]-23-|"
									],
									gxDefaultValue: "\u{26A0}\u{FE0F} Significant delay will be audible with this effects configuration."
								}
							}
						}
					},

				},
			}
		},
		gxChildViews: { 
			spacer: {
				nsClass: GXDrawView
			}, 
			sourceDelete: {
				"+": "deleteButton",
				gxToolTipKeyPath: "deleteSourceToolTip",
				axIsIgnored: true,
				gxIgnoreNextKeyView: true,
				gxLayerZPosition: kSourceListCollapsedElementLevel + 1,
			},
			sourceDeleteForAX: {
				nsClass: GXButtonView,
				gxBackPainter: {
					nsClass: "GXPainter",
					gxFillColor: null,
				},
				axIsIgnored: outputItem,
				gxIntrinsicHeight: 20,
				gxIntrinsicWidth: 20,
				axTitle: "Source Delete",
				gxValueKeyPath: "remove",
				gxIgnoreNextKeyView: true,
				gxLayerZPosition: kSourceListCollapsedElementLevel + 1,
			},
			sourceIcon: {
				"+": "ImageView",
				gxValueKeyPath: "sourceIcon",
				gxHideOnNilValue: true,
 				"gxImagePainter": {
					"+": "ImagePainter",
					gxTintColor: (sourceType != kApplicationSourceType) ? "name:fullGreen" : null,
				},
				axIsIgnored: true,
				gxLayerZPosition: kSourceListCollapsedElementLevel + 2,
			},
			sourceName: {
				"+": "LabelView.left.size13",
				gxIntrinsicWidth: -1,
				gxValueKeyPath: "sourceName",
				gxLayerZPosition: kSourceListCollapsedElementLevel + 3,
			}, 
			volumeIndicator: {
				nsClass: GXButtonView,
				axCheckboxRole: true,
				gxRangeMax: 4,
				gxIntrinsicHeight: 20,
				gxIntrinsicWidth: 20,
				gxBaselineOffset: 5,
				gxLayerZPosition: kSourceListCollapsedElementLevel + 1,
				gxStylesKeyPath: "volumeSliderStyles",
				gxForePainter: {
					"+" : "ImagePainter.volumeIndicator",
					gxTintColor: "name:speakerFill",
				},
				gxValueKeyPath: "userSetMute",
				axHelpKeyPath: "muteSourceToolTip",
				gxToolTipKeyPath: "muteSourceToolTip" 
			},
			volumeSlider: {
				"+": "SliderView",
				nsClass: "SoundSource.TCSliderView",
				isMainUISlider: true,
				gxPlayEffectsOnMouseUp: true,	
				gxStylesKeyPath: "volumeSliderStyles",
				gxDetents: "1",
				gxTrackMidRatio: 1.0,
				gxIgnoreDoubleClick: true,
				gxDefaultValue: 1.0,
				gxDisableOnNil: true,
				gxBaselineOffset: 5,
				gxEndGap: 10,
				gxReadoutTemplate: {
					"+": "SliderReadout.percentage.left.size11",
					gxClickValue: 1.0,
					gxBaselineOffset: 6,
				},
				gxKeystrokeStepSize: 0.0652,
				gxLargeKeystrokeStepSize: 2.0,
				gxLayerZPosition: kSourceListCollapsedElementLevel + 1,
				gxDetentPainter: detents,
				gxRangeMax: volumeSliderMax,
				axFormatter: "AXVolumeSliderFormatter",
				axRoleDescription: "Volume Slider",
				gxValueKeyPath: "userSetVolume",
				gxReadoutKeyPath: "userSetVolume",
				gxToolTipKeyPath: "volumeToolTip",
			},
			magicBoostButton: {
				gxIntrinsicWidth: 25,
				gxIntrinsicHeight: 25,
				axCheckboxRole: true,
				gxBaselineOffset: 7,
				nsClass: "SoundSource.TCMagicBoostButton",
				gxShowOnKey: "showMagicBoost",
				gxForePainter: {
					"+": "ImagePainter.icon-boost",
				},
				gxTitle: "",
				gxDisableOnNilValue: true,
				gxLayerZPosition: kSourceListCollapsedElementLevel + 1,
				gxValueKeyPath: "userSetBoost",
				axTitle: "Magic Boost",
				gxToolTip: "Enable Magic Boost",
				gxPressedToolTip: "Disable Magic Boost",
				magicBoostGrayBack: "name:controlBackFill",
				magicBoostLightGreen: "rgba:62,186,49,100",
				magicBoostPressed: "rgba:62,186,49,100",
				magicBoostDarkGreen: "name:fullGreen",
				magicBoostBorder: "name:controlFrame",
				magicBoostBlack: "name:black",
				magicBoostWhite: "name:white",
				
			},
			muteAlert: {
				"+" : "AlertButton",
				gxValueKeyPath: "showMuteAlert",
				gxShowOnKey: "showMuteAlert",
			},
			deviceAlert: {
				"+" : "AlertButton",
				gxValueKeyPath: "showDeviceAlert",
				gxShowOnKey: "showDeviceAlert",
			},
			levelMetersEnabled: {
				"+": "levelMeterDisplay",
				gxLayerZPosition: kSourceListCollapsedElementLevel + 1,
				gxLayout: [
					"H:[self(40)]",
					"V:|-14.5-[self(7)]"
				],
				gxShowOnKey: "routeMuted",
				"gxPeakValueKeyPath": "peakSummed",
				"gxClipValueKeyPath": "clipSummed",
			},
			levelMetersEnabled: {
				"+": "levelMeterDisplay",
				gxLayerZPosition: kSourceListCollapsedElementLevel + 1, 
				gxShowOnKey: "routeAudible",
				"gxPeakValueKeyPath": "peakSummed",
				"gxClipValueKeyPath": "clipSummed",
			},
			levelMetersDisabled: {
				"+": "levelMeterDisplay.disabled",
				gxLayerZPosition: kSourceListCollapsedElementLevel + 1,
				gxShowOnKey: "routeMuted",
				"gxPeakValueKeyPath": "peakSummed",
				"gxClipValueKeyPath": "clipSummed",
			},
			spinnerHolder: {
				nsClass: GXDrawView,
				gxLayerZPosition: kSourceListCollapsedElementLevel + 2,
				gxChildViews: {
					bluetoothConnectionSpinner: {
						nsClass: "NSProgressIndicator",
						gxLayout: [
							"H:|[self]|",
							"V:|[self]|",
						],
						gxIntrinsicHeight: 25,
						gxIntrinsicWidth: 15,
						gxValueKeyPath: "",
					},
				}
			},
			deviceSelectPopup: {
				"+": "PopupMenuView",
				nsClass: "SoundSource.TCAudioDevicePopupButton",
				gxForePainter: {
					"+": "FlatButtonFore.size12.left",
					gxEdgeInsets: "6,0,20,0",
				},
				gxBackPainter: {
					"+": "FlatButtonBack",
				}, 
				gxLayerZPosition: kSourceListCollapsedElementLevel + 1,
				gxValueKeyPath: "",
				axHelpKeyPath: "deviceSelectHelp",
				gxToolTipKeyPath: "deviceSelectToolTop",
				gxLabelText: null,
			},
			showEffectsButton: {
				nsClass: "SoundSource.TCShowEffectsButton", 
				axIsIgnored: true,
				gxIntrinsicHeight: 24,
				gxIntrinsicWidth: 24,
				gxBaselineOffset: 7,
				gxLayerZPosition: kSourceListCollapsedElementLevel + 1,
				gxValueKeyPath: "userToggleAdvancedView",
				gxDisableOnKey: "toggleAdvancedViewDisabled",
				gxHideOnNilValue: true,
				gxBackPainter: {
					nsClass: GXRoundRectPainter,
					gxEdgeInsets: "2,2,2,2",
					gxFillColor: "name:controlBackFill",
					gxFrameColor: "name:fontColor",
					"disabled" : {
						gxFrameColor: "name:darkGray"
					}
				},
				gxForePainter: {
					nsClass: GXRoundRectPainter,
					gxFrameColor: "name:controlFrame",
					"disabled" : {
						gxFrameColor: "name:lightMinty"
					}
				},
				gxTitle: "",
				gxToolTip: "Show advanced section",
				gxPressedToolTip: "Hide advanced section",
			},
			fxBadge : {
				nsClass: GXDrawView,
				gxIntrinsicWidth: 14,
				gxIntrinsicHeight: 9,
				gxValueKeyPath: "",
				gxShowOnKey: "advancedEffected",
				gxBackPainter: {
					"+" : "ImagePainter.fx-badge",
				},
				gxLayerZPosition: kSourceListCollapsedElementLevel + 3,
			}
		},
	}
};
 
